package net.h34t.filemure.controller

import io.javalin.http.Context
import net.h34t.filemure.TemplateModifiers
import net.h34t.filemure.repository.SqliteRepository
import net.h34t.filemure.requireSession
import net.h34t.filemure.tempolin
import net.h34t.filemure.tpl.Frame
import net.h34t.filemure.tpl.Overview

class OverviewController(val modifiers: TemplateModifiers, val repository: SqliteRepository) {

    fun overview(ctx: Context) {
        val session = ctx.requireSession()

        val limboFileCount = repository.getLimboFileCount(accountId = session.id)

        ctx.tempolin(
            Frame(
                modifiers = modifiers,
                title = "Filemure Overview",
                isTarget = true,
                content = Overview(
                    limboFileCount = limboFileCount.toString()
                )
            )
        )
    }
}